/*
 * Created on Aug 22, 2005
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 675 Mass
 * Ave, Cambridge, MA 02139, USA.
 * 
 * History
 * v1.0 - Aug 22, 2005 - Initial Release
 */

import java.io.IOException;
import java.io.FileNotFoundException;

class unlz77
{
	public static void main(String[] argv) throws IOException, FileNotFoundException
	{
		int flags, mask, encoded;
		byte buffer[] = new byte[4096];
		byte b;
		int size, index, i, length, temp_index;
		
		if (argv.length == 2) {
			LESimpleDataInputStream in = new LESimpleDataInputStream(argv[0]);
			LESimpleDataOutputStream out = new LESimpleDataOutputStream(argv[1]);
			
			index = 0;
			
			size = (in.readInt() >> 8);
			
			while (size > 0 && !in.eof()) {
				flags = in.readByte();
				for (mask = 128; size > 0 && mask != 0; mask >>= 1)
				{
					if ((flags & mask) != 0) {
						encoded = in.readChar();
						length = ((encoded >> 4) & 15) + 3;
						temp_index = (index + (1<<12) - ((encoded & 15) << 8) - (encoded >> 8) - 1) % (1 << 12);
						for (i = 0; i < length; i++) {
							out.writeByte(buffer[temp_index]);
							buffer[index] = buffer[temp_index];
							temp_index = (temp_index + 1) % (1 << 12);
							index = (index + 1) % (1 << 12);
						}
						size -= length;
					} else {
						size--;
						b = in.readByte();
						buffer[index] = b;
						index = (index + 1) % (1 << 12);
						out.writeByte(b);
					}
				}
			}
		}
	}
}
