#!/usr/bin/python

from glob import glob
import os, sys
from struct import unpack
from sys import argv
from stat import *

GLOBAL_CHECKSUM = 0x14e
ID = 0x104

ID_VAL = 0x6666edce

def readfile(name):
	try:
		fd = open(name, "rb")
		contents = fd.read()
		fd.close()
	except IOError:
		print "Error reading", name
		sys.exit(1)
	return contents

if __name__ == "__main__":
	if len(argv) < 2:
		print "Usage: %s game.gb [... game.gb]"
		sys.exit(0)
	args = argv[1:]
	if sys.platform == "win32":
		tmp = []
		for a in args:
			expanded = glob(a)
			if len(expanded) == 0:
				tmp.append(a)
			else:
				tmp.extend(expanded)
		args = tmp
	for a in args:
		game = readfile(a)
		if len(game) < 0x150 or unpack("<I", game[ID:ID+4])[0] != ID_VAL:
			print a
			print "Not a valid GB game"
		else: 
			print a
			print "CRC: 0x%04X" % unpack(">H", game[GLOBAL_CHECKSUM:GLOBAL_CHECKSUM+2])[0]
